100  REMark do_sprt_bas - 24 NOV 08
110 :
120 DEFine PROCedure Set_Sprite(o%,a$)
130 :
140  REMark ********************************************************
150  REMark * sets sprite (o%= 0, 2 or 3*256 + T)                  *
160  REMark *      blob   (o% =1)                                  *
170  REMark *      patt   (o% =-1)                                 *
180  REMark *                                                      *
190  REMark * For sprites; o% = 0 for opaque                       *
200  REMark *                 = 2 for transparent                  *
210  REMark *                 = 3*256 + T for T/255 transparency   *
220  REMark *                   (255 = opaque, 0 = invisible)      *
230  REMark *                                                      *
240  REMark * The sprite is set to "ram1_"&a$&"_spr"               *
250  REMark * The blob is set to "ram1_"&a$&"_blo"                 *
260  REMark * The pattern is set to "ram1_"&a$&"_pat"              *
270  REMark ********************************************************
280 :
290  LOCal spad,reduc,kkp%
300  kkp%=o%
310  RESTORE 1000:spad=Rd_Sprt(o%)
315  IF spad=0:CLS:PRINT "No item":RETurn
320 :
330  REMark *************************************************************
340  REMark * The type and form of sprite/blob/pattern comes from 1000  *
350  REMark * The sprite/blob/pattern is now @ address spad (or -spad)  *
360  REMark * Gze returns the length of the sprite in ram but 1st we    *
370  REMark * must set "spad" and "reduc"                               *
380  REMark *************************************************************
390 :
400  IF spad<0:reduc=1:spad=-spad:ELSE :reduc=0
410  SBYTES_O Sp_Nme$,spad,Gze(kkp%)
420  DEALLOCATE spad
430 END DEFine
440 :
450 DEFine FuNction Gze(o%)
460  LOCal wd%,ht%,ty,tz
470 :
480  REMark *************************************************************
490  REMark * The dimensions of the sprite are taken from "spad".       *
500  REMark * These are used as parameters for SPR_SZE which gives the  *
510  REMark * size of the sprite.                                       *
520  REMark * If reduc <> 0 the size must be reduced.                   *
530  REMark *************************************************************
540 :
550  wd%=PEEK_W(spad+4):ht%=PEEK_W(spad+6)
560  ty=PEEK(spad+1):tz=wd%*ht%+12
570  SELect ON ty
580   =31:wd%=-wd%
590   =32,33:ht%=-ht%:wd%=-wd%
600  END SELect
610  ty=SPR_SZE(wd%,ht%):IF o% DIV 256=3:ty=ty/2+tz
620  IF reduc:ty=ty/2+12
630  RETurn ty
640 END DEFine
650 :
660 DEFine FuNction Sp_Nme$
670  LOCal ty,b$(30)
680  REMark *************************************************************
690  REMark * This function adds the trailer to the name -              *
700  REMark *   _spr, _blo or _pat                                      *
710  REMark *************************************************************
720  ty=o%
730  SELect ON ty
740   =0,2:b$="_spr"
750   =1:b$="_blo"
760   =-1:b$="_pat"
770  END SELect
780  RETurn "ram1_"&a$&b$
790 END DEFine
800 :
810  REMark *********************************************************
820  REMark * The first line of data is x-origin, y-origin and mode *
830  REMark * the following lines give the form of the sprite.      *
840  REMark * The mode 4 colours are:                               *
850  REMark *      a - blAck                                        *
860  REMark *      r - Red                                          *
870  REMark *      g - Green                                        *
880  REMark *      w - White                                        *
890  REMark *        - transparent (Space)                          *
900  REMark * The last DATA line must be '' (or "") to signal END   *
910  REMark *********************************************************
920 :
1000 DATA 0,0,32
1002 DATA '       a'
1012 DATA '      awa'
1022 DATA '     awaa'
1032 DATA '    awaawa'
1042 DATA '   awaawaa'
1052 DATA '  awaawaawa'
1062 DATA ' awaawaawa'
1072 DATA 'awaawaawa'
1082 DATA ' a  a  a',''
1092 DATA 'gggggggggggggggggggggggggg'
1102 DATA 'gggggggggggggggggggggggggg'
1111 DATA 'gggggggggggggggggggggggggg'
1115 DATA 'gggggggggggggggggggggggggg',''
1120 :
18050 DEFine PROCedure ss
18060  SAVE win1_qptr_basic_do_sprt_bas
18070 END DEFine
18080 :
22328 REFERENCE _address
22332 DEFine PROCedure _Spoke_W(_address,_item%)
22336  IF _address+2>_top:PRINT#0,"Spoke_W would overrun "&_grub$:Stip
22340  POKE_W _address,_item%:_address=_address+2
22344 END DEFine
22348 :
22352 REFERENCE _address
22356 DEFine PROCedure _Spoke$(_address,_item$)
22360  IF LEN(_item$)+_address>_top:PRINT#0,"Spoke$ would overrun "&_grub$:Stip
22364  POKE$ _address,_item$:_address=_address+_m%
22368 END DEFine
22372 :
22376 REFERENCE _address
22380 DEFine PROCedure _Spoke_L(_address,_item)
22384  IF _address+4>_top:PRINT#0,"Spoke_L would overrun "&_grub$:Stip
22388  POKE_L _address,_item:_address=_address+4
22392 END DEFine
22396 :
22400 REFERENCE _address
22404 DEFine PROCedure _Spoke(_address,_item%)
22408  IF _address+1>_top:PRINT#0,"Spoke would overrun "&_grub$:Stip
22416  POKE _address,_item%:_address=_address+1
22420 END DEFine
22424 :
22960 DEFine FuNction Ev%(_s%)
22964  REMark makes s% even
22968  RETurn (_s%&&1)+_s%
22972 END DEFine
22976 :
27000 DEFine FuNction Rd_Sprt(_o%)
27002   REMark o%=0 for sprite:2 for XOR sprite:3 + l for alpha channel
27004   REMark o%=1 for blob:-1 for pattern
27006   REMark returns -lp if length shortened
27008   LOCal _tmp_patt$(50,50),_k,_l,_tmp1$(0,100),_trans%,_bk
27010   LOCal _xs%,_ys%,_xo,_yo,_md,_lp,_x,_y,_m%,_o2%,_o3%,_top,_sze,_sze1,_dd
27012   _xs%=0:_ys%=-1:READ _xo,_yo,_md:DIM _grub$(14):_grub$=" Sprite Space"
27014   IF _o% DIV 256=3:_trans%=_o% MOD 256:_o%=0:ELSE _trans%=-1
27016   REPeat _lp
27018     READ _tmp1$(0):IF _tmp1$(0)='' THEN EXIT _lp
27020     _ys%=_ys%+1:IF _ys%>50:RETurn 0:ELSE :_tmp_patt$(_ys%)=_tmp1$(0)
27022     IF LEN(_tmp1$(0))>_xs% THEN _xs%=LEN(_tmp1$(0))
27024   IF _xs%=0 OR _xs%>50 OR _ys%=-1:RETurn 0:REMark Error - no sprite/blob/pattern
27026   END REPeat _lp
27028   SELect ON _md
27030    =31:_Do_Sp 543,_ys%+1,1
27032    =32:_Do_Sp 544,-_ys%-1,0
27034    =33:_Do_Sp 545,-_ys%-1,0
27036    =4,8:_Do_Sp1
27038    =REMAINDER :RETurn 0:REMark Error
27040   END SELect
27042   _k=_o%
27044   SELect ON _k
27046    =0:RETurn _lp
27048    =2:_Xor_Sp:RETurn _lp
27050    =1:_R_Blob:RETurn -_lp
27052    =-1:_xo=_R_Pattern%:IF NOT _xo:DEALLOCATE _lp:RETurn 0:ELSE :RETurn _xo*_lp
27054    =REMAINDER :RETurn 0:REMark error
27056   END SELect
27058 END DEFine
27060 :
27062 DEFine PROCedure _Do_Sp(o2%,o3%,o4%)
27064   LOCal _b$(50)
27066     _sze=SPR_SZE(-_xs%,o3%):_Adj_sze
27068     _lp=ALLOCATION(_sze1):_l=_lp:_top=_sze1+_l
27070     _Spoke_W _l,o2%:_Spoke_W _l,32*(_trans%>-1)
27072     _Spoke_W _l,_xs%:_Spoke_W _l,_ys%+1
27074     _Spoke_W _l,_xo:_Spoke_W _l,_yo
27076     _Spoke_L _l,12
27078     _Spoke_L _l,8+(_sze-24)/2:_Spoke_L _l,0:_dd=_l+_bk
27080     FOR _x=0 TO _ys%:_b$=_tmp_patt$(_x):_Fill_Line2 o4%
27082 END DEFine
27084 :
27086 DEFine PROCedure _Fill_Line2(_k)
27088  IF _k:_Fill_Line1:ELSE _Fill_Line
27090 END DEFine
27092 :
27094 DEFine PROCedure _Do_Sp1
27096     _sze=SPR_SZE(_xs%*_md/4,_ys%+1):_Adj_sze:_lp=ALLOCATION(_sze1)
27098     DIM _tmp1$(_ys%,_xs%)
27100     _m%=DIMN(_tmp1$,2)
27102     FOR _x=0 TO _ys%:_tmp1$(_x)=_tmp_patt$(_x)&FILL$(' ',50)
27104     _top=(DIMN(_tmp1$)+1)*(_m%+2)+14
27106     _k=ALLOCATION(_top):_top=_k+_top
27108     _l=_k
27110     _Spoke_L _l,14
27112     _Spoke_W _l,2
27114     _Spoke_W _l,_ys%
27116     _Spoke_W _l,_m%+2
27118     _Spoke_W _l,_m%
27120     _Spoke_W _l,1
27122     FOR _x=0 TO _ys%:_Spoke_W _l,_m%:_Spoke$ _l,_tmp1$(_x)
27124     BSPSET _lp,_xo,_yo,_md,_k,_trans%
27126     DEALLOCATE _k:_top=_lp+_sze1
27128 END DEFine
27130 :
27132 DEFine PROCedure _R_Blob
27134  REMark to take out colour
27136  LOCal _x,_s,_k
27138  _s=(_sze-24)/2
27140  POKE_L _lp+12,0:REMark no colour
27142  _k=_lp+16+PEEK_L(_lp+16):POKE_L _lp+16,8:REMark for closing up
27144  FOR _x=1 TO _s:POKE _lp+23+_x,PEEK(_k+_x-1)
27146 END DEFine
27148 :
27150 DEFine FuNction _R_Pattern%
27152  REMark returns 1 if no change:-1 if smaller size:0 if error
27154  LOCal _mark%,_x,_y,_k
27156  POKE_L _lp+8,0:REMark 'origin' -> 0
27158   _k=_lp+16+PEEK_L(_lp+16):_mark%=-1
27160  SELect ON _md
27162   =4,8
27164   IF _xs% MOD 8:RETurn 0
27166   _s=((_sze-24) DIV 4) DIV (_ys%+1)
27168   FOR _y=0 TO _ys%
27170    FOR _x=1 TO _xs%/4:IF PEEK_W(_k+_x-1+_y*_s)<>$FFFF:_mark%=1:EXIT _x
27172    IF _mark%=1:EXIT _y
27174   END FOR _y
27176   =31
27178   IF _xs% MOD 4:RETurn 0
27180   _s=((_sze-24) DIV 8) DIV (_ys%+1)
27182   FOR _y=0 TO _ys%
27184    FOR _x=1 TO _xs%/4:IF PEEK_L(_k+_y*_s)<>$FFFFFFFF:mark%=1:EXIT _x
27186    IF _mark%=-1:EXIT _y
27188   END FOR _y
27190   =32,33
27192   IF _xs% MOD 2:RETurn 0
27194   _s=((_sze-24) DIV 8) DIV (_ys%+1)
27196   FOR _y=0 TO _ys%
27198    FOR _x=1 TO _xs%/2:IF PEEK_L(_k+_y*_s)<>$FFFFFFFF:_mark%=-1:EXIT _x
27200    IF _mark%=-1:EXIT _y
27202   END FOR _y
27204  END SELect
27206  IF _mark%=-1:POKE_L _lp+16,0:REMark no pattern
27208  RETurn _mark%
27210 END DEFine
27212 :
27214 DEFine PROCedure _Fill_Line
27216  REMark Given b$, to set ev%(xs%) bytes to "l"
27218  LOCal _c$(_xs%),_x,_wob%
27220  IF _trans%=-1:_dd=_l+_bk:REMark size of block + where we are
27222  _c$=_b$&FILL$(' ',2*Ev%(_xs%)-LEN(_b$))
27224  FOR _x=1 TO Ev%(_xs%)
27226   IF _x>_xs%
27228    _Spoke_W _l,0
27230    IF _trans%=-1:_Spoke_W _dd,0
27232   ELSE
27234    _wob%=_E_Cil%(_c$(_x))
27236    IF _trans%=-1
27238     IF _wob%=-1:_Spoke_W _dd,0:_wob%=0:ELSE :_Spoke_W _dd,-1
27240    ELSE
27242     IF _wob%=-1:_Spoke _dd,0:_wob%=0:ELSE :_Spoke _dd,_trans%
27244    END IF
27246    _Spoke_W _l,_wob%:REMark Set Black both for Black and for SPACE
27248   END IF
27250  END FOR _x
27252 END DEFine
27254 :
27256 DEFine PROCedure _Fill_Line1
27258  REMark Given b$, to set ev%(xs%) bytes to "l"
27260  LOCal _c$(_xs%),_x,_wob%,_xv%
27262  IF _trans%=-1:_dd=_l+_bk:REMark size of block + where we are
27264  _xv%=2*Ev%(Ev%(_xs%)/2):REMark number of bytes / line
27266  _c$=_b$&FILL$(' ',_xv%-LEN(_b$))
27268  FOR _x=1 TO _xv%
27270   IF _x>_xs%
27272    _Spoke _l,0
27274    IF _trans%=-1:_Spoke _dd,0
27276   ELSE
27278    _wob%=_E_Cil1%(_c$(_x))
27280    IF _wob%=-1:_Spoke _dd,0:_wob%=0:ELSE :_Spoke _dd,_trans%
27282    _Spoke _l,_wob%:REMark Set Black both for Black and for SPACE
27284   END IF
27286  END FOR _x
27288 END DEFine
27290 :
27292 DEFine FuNction _E_Cil%(_a$)
27294  REMark 64 characters are translated to the Q40 native
27296  REMark colour code corresponding to the 64 palette colours
27298  LOCal _c,_ans%
27300  _c=CODE(_a$)
27302  SELect ON _c
27304   =32:RETurn -1:REMark signal SPACE
27306   =CODE('a'):_ans%= 0:REMark a = Black
27308   =CODE('u'):_ans%= 62:REMark u = Blue
27310   =CODE('r'):_ans%= 1984:REMark r = Red
27312   =CODE('m'):_ans%= 2046:REMark m = Magenta
27314   =CODE('g'):_ans%= -2048:REMark g = Green
27316   =CODE('c'):_ans%= -1986:REMark c = Cyan
27318   =CODE('y'):_ans%= -64:REMark y = Yellow
27320   =CODE('w'):_ans%= -2:REMark w = White
27322   =CODE('0'):_ans%= 8456:REMark 0 = Dark Slate
27324   =CODE('1'):_ans%= 19026:REMark Slate Grey
27326   =CODE('2'):_ans%= 27482:REMark Dark Grey
27328   =CODE('3'):_ans%= -27484:REMark Grey
27330   =CODE('4'):_ans%= -19028:REMark Light Grey
27332   =CODE('5'):_ans%= -8458:REMark Ash Grey
27334   =CODE('6'):_ans%= 1152:REMark Dark Red
27336   =CODE('7'):_ans%= -596:REMark Light Green
27338   =CODE('8'):_ans%= -27520:REMark Mustard
27340   =CODE('9'):_ans%= -28672:REMark Dark Green
27342   =CODE('b'):_ans%= -28636:REMark Sea Blue
27344   =CODE('d'):_ans%= 36:REMark Dark Blue
27346   =CODE('e'):_ans%= 1188:REMark Purple
27348   =CODE('f'):_ans%= 2020:REMark Shocking Pink
27350   =CODE('h'):_ans%= -26688:REMark Orange
27352   =CODE('i'):_ans%= -896:REMark Lime Green
27354   =CODE('j'):_ans%= -2012:REMark Apple Green
27356   =CODE('k'):_ans%= -28610:REMark Bright Blue
27358   =CODE('l'):_ans%= 1214:REMark Mauve
27360   =CODE('n'):_ans%= -18452:REMark Peach
27362   =CODE('o'):_ans%= -20:REMark Light Yellow
27364   =CODE('p'):_ans%= -578:REMark Light Blue
27366   =CODE('q'):_ans%= -19010:REMark Sky Blue
27368   =CODE('s'):_ans%= -18434:REMark Rose Pink
27370   =CODE('t'):_ans%= -18442:REMark Pink
27372   =CODE('v'):_ans%= -8212:REMark Beige
27374   =CODE('x'):_ans%= -8202:REMark Pastel Pink
27376   =CODE('z'):_ans%= -10:REMark Pastel Yellow
27378   =CODE('A'):_ans%= -266:REMark Pastel Green
27380   =CODE('B'):_ans%= -258:REMark Pastel Cyan
27382   =CODE('C'):_ans%= -8450:REMark Pastel Blue
27384   =CODE('D'):_ans%= -8194:REMark Pastel Rose
27386   =CODE('E'):_ans%= 28058:REMark Brick
27388   =CODE('F'):_ans%= -19046:REMark Light Khaki
27390   =CODE('G'):_ans%= -19622:REMark Dull Green
27392   =CODE('H'):_ans%= -19604:REMark Dull Cyan
27394   =CODE('I'):_ans%= 27500:REMark Steel Blue
27396   =CODE('J'):_ans%= 28076:REMark Dull Pink
27398   =CODE('K'):_ans%= 9032:REMark Brown
27400   =CODE('L'):_ans%= 27464:REMark Khaki
27402   =CODE('M'):_ans%= 26888:REMark Dusky Green
27404   =CODE('N'):_ans%= 26906:REMark Dusky Blue
27406   =CODE('O'):_ans%= 8474:REMark Midnight Blue
27408   =CODE('P'):_ans%= 9050:REMark Plum
27410   =CODE('Q'):_ans%= 19876:REMark Dusky Pink
27412   =CODE('R'):_ans%= -27246:REMark Buff
27414   =CODE('S'):_ans%= -19310:REMark Avocado
27416   =CODE('T'):_ans%= -19868:REMark Dull Turquoise
27418   =CODE('U'):_ans%= -28052:REMark Dull Blue
27420   =CODE('V'):_ans%= 19628:REMark Faded Purple
27422   =CODE('W'):_ans%= 1170:REMark Cerise
27424   =CODE('X'):_ans%= 19584:REMark Tan
27426   =CODE('Y'):_ans%= -28096:REMark Grass Green
27428   =CODE('Z'):_ans%= -28654:REMark Sea Green
27430   =CODE('['):_ans%= 18468:REMark Ultramarine
27432   =CODE(']'):_ans%= 612:REMark Deep Purple
27434   =REMAINDER :RETurn 0:REMark ERROR - take as Black
27436  END SELect
27438  IF _md=32:_ans%=CL33T32(_ans%,1,1)
27440  RETurn _ans%
27442 END DEFine
27444 :
27446 DEFine PROCedure _Xor_Sp
27448  REMark To clear the pattern mask for sprite @ lp
27450  LOCal _d,_k,_x
27452  _d=PEEK_L(_lp+16):_k=2+(_d-PEEK_L(_lp+12))/2:_d=_d+_lp+16
27454  FOR _x=1 TO _k:_Spoke_W _d,0
27456 END DEFine
27458 :
27460 DEFine FuNction _E_Cil1%(_a$)
27462  REMark 64 characters are translated to the palette
27464  REMark colour code corresponding to the 64 palette colours
27466  LOCal _c
27468  _c=CODE(_a$)
27470  SELect ON _c
27472   =32:RETurn -1:REMark signal SPACE
27474   =CODE('a'):RETurn 0:REMark a = Black
27476   =CODE('u'):RETurn 4:REMark u = Blue
27478   =CODE('r'):RETurn 2:REMark r = Red
27480   =CODE('m'):RETurn 5:REMark m = Magenta
27482   =CODE('g'):RETurn 3:REMark g = Green
27484   =CODE('c'):RETurn 7:REMark c = Cyan
27486   =CODE('y'):RETurn 6:REMark y = Yellow
27488   =CODE('w'):RETurn 1:REMark w = White
27490   =CODE('0'):RETurn 8:REMark 0 = Dark Slate
27492   =CODE('1'):RETurn 9:REMark Slate Grey
27494   =CODE('2'):RETurn 10:REMark Dark Grey
27496   =CODE('3'):RETurn 11:REMark Grey
27498   =CODE('4'):RETurn 12:REMark Light Grey
27500   =CODE('5'):RETurn 13:REMark Ash Grey
27502   =CODE('6'):RETurn 14:REMark Dark Red
27504   =CODE('7'):RETurn 15:REMark Light Green
27506   =CODE('8'):RETurn 16:REMark Mustard
27508   =CODE('9'):RETurn 17:REMark Dark Green
27510   =CODE('b'):RETurn 18:REMark Sea Blue
27512   =CODE('d'):RETurn 19:REMark Dark Blue
27514   =CODE('e'):RETurn 20:REMark Purple
27516   =CODE('f'):RETurn 21:REMark Shocking Pink
27518   =CODE('h'):RETurn 22:REMark Orange
27520   =CODE('i'):RETurn 23:REMark Lime Green
27522   =CODE('j'):RETurn 24:REMark Apple Green
27524   =CODE('k'):RETurn 25:REMark Bright Blue
27526   =CODE('l'):RETurn 26:REMark Mauve
27528   =CODE('n'):RETurn 27:REMark Peach
27530   =CODE('o'):RETurn 28:REMark Light Yellow
27532   =CODE('p'):RETurn 29:REMark Light Blue
27534   =CODE('q'):RETurn 30:REMark Sky Blue
27536   =CODE('s'):RETurn 31:REMark Rose Pink
27538   =CODE('t'):RETurn 32:REMark Pink
27540   =CODE('v'):RETurn 33:REMark Beige
27542   =CODE('x'):RETurn 34:REMark Pastel Pink
27544   =CODE('z'):RETurn 35:REMark Pastel Yellow
27546   =CODE('A'):RETurn 36:REMark Pastel Green
27548   =CODE('B'):RETurn 37:REMark Pastel Cyan
27550   =CODE('C'):RETurn 38:REMark Pastel Blue
27552   =CODE('D'):RETurn 39:REMark Pastel Rose
27554   =CODE('E'):RETurn 40:REMark Brick
27556   =CODE('F'):RETurn 41:REMark Light Khaki
27558   =CODE('G'):RETurn 42:REMark Dull Green
27560   =CODE('H'):RETurn 43:REMark Dull Cyan
27562   =CODE('I'):RETurn 44:REMark Steel Blue
27564   =CODE('J'):RETurn 45:REMark Dull Pink
27566   =CODE('K'):RETurn 46:REMark Brown
27568   =CODE('L'):RETurn 47:REMark Khaki
27570   =CODE('M'):RETurn 48:REMark Dusky Green
27572   =CODE('N'):RETurn 49:REMark Dusky Blue
27574   =CODE('O'):RETurn 50:REMark Midnight Blue
27576   =CODE('P'):RETurn 51:REMark Plum
27578   =CODE('Q'):RETurn 52:REMark Dusky Pink
27580   =CODE('R'):RETurn 53:REMark Buff
27582   =CODE('S'):RETurn 54:REMark Avocado
27584   =CODE('T'):RETurn 55:REMark Dull Turquoise
27586   =CODE('U'):RETurn 56:REMark Dull Blue
27588   =CODE('V'):RETurn 57:REMark Faded Purple
27590   =CODE('W'):RETurn 58:REMark Cerise
27592   =CODE('X'):RETurn 59:REMark Tan
27594   =CODE('Y'):RETurn 60:REMark Grass Green
27596   =CODE('Z'):RETurn 61:REMark Sea Green
27598   =CODE('['):RETurn 62:REMark Ultramarine
27600   =CODE(']'):RETurn 63:REMark Deep Purple
27602   =REMAINDER :RETurn 0:REMark ERROR - take as Black
27604  END SELect
27606 END DEFine
27608 :
27610 DEFine PROCedure _Adj_sze
27612  REMark To reset Sprite size if alpha channel
27614  REMark trans%=-1 for no channel
27616  _bk=(_sze-24)/2:_sze1=_sze
27618  IF _trans%>-1: _sze1=24+_bk+_xs%*(_ys%+1)
27620 END DEFine
27622 :
